package com.gmh.utils;

import org.apache.poi.hssf.usermodel.HSSFWorkbook;
import org.apache.poi.ss.usermodel.Sheet;
import org.apache.poi.ss.usermodel.Workbook;
import org.apache.poi.xssf.usermodel.XSSFWorkbook;

import java.io.*;

/**
 * POI Excel工具类
 * created on 2020/5/28 10:08
 *
 * @author puhaiyang
 */
public class POIExcelUtil {

    public static void main(String[] args) throws IOException {
        File file = new File("C:\\Users\\xxche\\Desktop\\20221106_test_excel\\附件3.继续教育证明.xls");
        Workbook workbook = batchCloneSheet(file, 0, 50);
        try {
            FileOutputStream out = new FileOutputStream("C:\\Users\\xxche\\Desktop\\20221106_test_excel\\附件3.继续教育证明222.xls");
            out.flush();
            workbook.write(out);
            out.close();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    public static Workbook cloneSheet(File excelFile, String srcSheetName, String destSheetName) throws IOException {
        Workbook wb = readExcelFromFile(excelFile);
        int index = wb.getSheetIndex(srcSheetName);
        return cloneSheet(excelFile, index, destSheetName);
    }

    public static Workbook cloneSheet(File excelFile, Integer index, String destSheetName) throws IOException {
        Workbook wb = readExcelFromFile(excelFile);
        //克隆一个新的sheet
        Sheet newSheet = wb.cloneSheet(index);
        int sheetIndex = wb.getSheetIndex(newSheet);
        wb.setSheetName(sheetIndex, destSheetName);
        return wb;

    }

    /**
     * 复制多个sheet
     *
     * @param excelFile
     * @param index     起始sheet
     * @param total     复制多个sheet
     */
    public static Workbook batchCloneSheet(File excelFile, Integer index, Integer total) throws IOException {
        Workbook wb = readExcelFromFile(excelFile);
        for (int i = 0; i < total; i++) {
            //克隆一个新的sheet
            Sheet newSheet = wb.cloneSheet(index);
            int sheetIndex = wb.getSheetIndex(newSheet);
            wb.setSheetName(sheetIndex, String.valueOf(i + 1));
        }
        wb.removeSheetAt(index);
        return wb;

//        try {
//            FileOutputStream out = new FileOutputStream(excelFile);
//            out.flush();
//            sheets.write(out);
//            out.close();
//        } catch (IOException e) {
//            e.printStackTrace();
//        }
    }

    //读取excel
    public static Workbook readExcelFromFile(File file) throws IOException {
        if (file == null) {
            return null;
        }
        String fileName = file.getName();
        String[] split = fileName.split("\\.");
        if (split.length == 0 || split.length == 1) {
            throw new RuntimeException("文件格式错误");
        }
        String suffix = split[split.length - 1];
        if ("xls".equals(suffix)) {
            return new HSSFWorkbook(new FileInputStream(file));
        } else if ("xlsx".equals(suffix)) {
            return new XSSFWorkbook(new FileInputStream(file));
        } else {
            throw new RuntimeException("文件格式错误，不是一个正经的Excel");
        }
    }
}